#INCLUDE "fbgfx.bi"
#INCLUDE "file.bi"
#INCLUDE "retrogra.bi"

' #note:
' code is not yet safe for characters above 2147483647 (=> signed integer) - echar, but not (mouse) coordinates

DECLARE FUNCTION SAVEFONT AS boolean
DECLARE SUB LOADFONT
DECLARE SUB GETCHAR(BYVAL AS UINTEGER)
DECLARE SUB SETCHAR(BYVAL AS UINTEGER)
DECLARE SUB DRAWCHAROVERVIEW()


DIM SHARED AS INTEGER i, j ' all-purpose integers / indicies
DIM AS INTEGER mx, my, b ' mouse coordinates+mousebutton
DIM AS INTEGER x, y, c ' coordinates, colour
DIM SHARED AS UBYTE consolefontcontent()
DIM SHARED AS UBYTE PTR bufptr
DIM SHARED AS UINTEGER consolefontsize ' font file in bytes
DIM SHARED AS ULONG consolefontpageoffset(512)
DIM SHARED AS USHORT charbuffer(16), charclipb(16) ' cur. edited character's bitmap in memory => font file format
DIM SHARED AS INTEGER pvx, pvy ' offsets preview window
DIM SHARED AS UINTEGER echar, ochar, epage ' currently edited char (including "page") / first "page" (0-511) in current editor view

' "MAIN" variables
DIM key AS STRING ' hit key char
DIM oclock AS DOUBLE, mclock AS DOUBLE
DIM mbdown AS INTEGER
DIM AS BYTE PTR cbitmap
DIM changesmade AS boolean ' changes made ?

rgSCREENNEW

' init variables
oclock=TIMER
mclock=0
pvx=200
pvy=16
mbdown=0
echar=65 ' A in "page" 0
epage=0  ' Basic Latin ("ASCII")
ochar=echar
cbitmap=IMAGECREATE(8,16)
changesmade=FALSE

LOADFONT

' *** draw interface ***
' "CLS" (white is the correct background colour)
LINE (0,0)-(640,480), 215, BF
' Editor windows
LINE (14,14)-(144,272), 0, B
LINE (pvx-2,pvy-2)-(pvx+25,pvy+49), 0, B

' fill editing window
GETCHAR(echar)
' draw character selection board
DRAWCHAROVERVIEW

rgSCREENSHOW

' MAIN (loop)
DO
  rgGETMOUSE (mx,my,,b)
  key=INKEY

  IF b THEN ' mouse pressed
    IF mx>15 AND mx<144 AND my>15 AND my<271 THEN ' inside edit window => edit
      x=mx-16
      x SHR=4
      y=my-16
      y SHR=4
      IF mbdown<>b THEN ' pressed button changed
        ' determine pixel colour below mouse pointer
        IF (charbuffer(y) AND (1 SHL x))<>0 THEN
          c=0
        ELSE
          c=215
        ENDIF
        IF mbdown=0 THEN ' button new pressed
          IF b=1 THEN ' left mouse button => normal draw
            IF c<>0 THEN c=0 ELSE c=215 ' switch drawing colour
            mbdown=1
          ELSEIF b=2 THEN ' right mouse button => inverted draw
            IF c=0 THEN c=215 ELSE c=0 ' switch drawing colour
            mbdown=2
          ENDIF
        ENDIF
      ENDIF

      ' drawing the "preview"
      x+=pvx
      y+=pvy
      FOR i=8 TO 0 STEP -1 ' repeat 9 times
        PSET (x,y),c
        x+=8
        IF x>pvx+23 THEN
          x-=24
          y+=16
        ENDIF
      NEXT
      y-=48
      x-=pvx
      y-=pvy

      ' set/clear bit
      IF c<>0 THEN
        charbuffer(y) AND =(&HFFFF XOR (1 SHL x))
      ELSE
        charbuffer(y) OR=(1 SHL x)
      ENDIF
      changesmade=TRUE

      ' drawing magnified pixels
      x SHL=4
      x+=16
      y SHL=4
      y+=16
      LINE (x, y)-(x+14, y+14), c, BF
    ENDIF

    ' character overview click
    IF mbdown=0 THEN ' only deliberate clicks
      IF my>=320 AND mx<512 THEN ' character selection
        IF ochar<&HFFFF THEN ' last edited char is valid
          GET (pvx,pvy)-(pvx+7,pvy+15),cbitmap ' "dirty" actualisation
          SETCHAR(ochar) ' update font file data
          x=echar MOD 64 ' get coordinates of current char in view
          x SHL=3
          y=int(echar/64)-(epage SHL 1)
          y SHL=4
          y+=320
          PUT (x,y),cbitmap,PSET ' putting current char's bitmap in view
        endif
        ' turning mouse coordinates into char code and coordinates
        x=mx SHR 3 ' :8
        y=my-320
        y SHR=4    ' :16
        IF consolefontpageoffset((y SHR 1)+epage) THEN
          echar=(y SHL 6)+(epage SHL 7)+x
          ' #todo: check
          IF ochar<>echar THEN ' only redraw if different character selected
            GETCHAR(echar) ' show
            ochar=echar
          ENDIF
          changesmade=TRUE
          mbdown=1
        ELSE
          mclock=TIMER
          rgSETMOUSE 10
        ENDIF
      ENDIF
    ENDIF
  ELSE ' mouse not pressed
    IF mbdown THEN ' ...no longer pressed
      mbdown=0
    ENDIF
  ENDIF

  IF key>"" THEN ' process key presses
    IF key=CHR(27) THEN ' ESC = Quit
      key="q"
    ENDIF
    IF key="q" THEN ' Quit
      ' <- confirmation procedere maybe ->
      IF changesmade THEN
        ' #todo: prompt whether to save or drop changes
        ' SAVEFONT
      ENDIF
      ' key="" ' abort quitting
    ENDIF
    IF key="s" THEN ' Save
      SETCHAR(ochar) ' update font file data
      SAVEFONT
      changesmade=FALSE
    ENDIF
    IF key="l" THEN ' Load (old version)
      ' #todo:
    ENDIF
    IF key="z" THEN ' Undo
      GETCHAR(echar)
    ENDIF
    IF key="c" THEN ' Copy
      ' current buffer content, not font file content
      FOR y=0 TO 15
        charclipb(y)=charbuffer(y)
      NEXT
    ENDIF
    IF key="v" THEN ' Paste
      FOR y=0 TO 15
        charbuffer(y)=charclipb(y)
      NEXT
      GETCHAR(-1) ' only draw char from buffer
    ENDIF
    IF key=CHR(255,80) or key=CHR(255,72) THEN ' browse to "pages"
      IF ochar<&HFFFF THEN ' last edited char is valid
        ' save the last edited char
        GET (pvx,pvy)-(pvx+7,pvy+15),cbitmap ' "dirty" actualisation
        SETCHAR(ochar) ' update font file data
        x=echar MOD 64 ' get coordinates of current char in view
        x SHL=3
        y=int(echar/64)-(epage SHL 1)
        y SHL=4
        y+=320
        PUT (x,y),cbitmap,PSET ' putting current char's bitmap in view
      ENDIF
      IF  key=CHR(255,72) THEN ' browse to previous "pages"
        IF epage>1 THEN
          epage-=2
          echar=-1 ' unassigned
          ochar=-1
          DRAWCHAROVERVIEW
        ELSE
          rgSETMOUSE 10
          mclock=TIMER
        ENDIF
      ELSE ' browse to next "pages"
        IF epage<200 THEN ' random limitation; highest alowed value is 507
          epage+=2
          echar=-1 ' unassigned
          ochar=-1
          ' draw character selection board
          DRAWCHAROVERVIEW
        ELSE
          rgSETMOUSE 10
          mclock=TIMER
        ENDIF
      ENDIF
    ENDIF
  ENDIF

  IF b=0 THEN
    SLEEP 1
    rgSCREENSHOW
    oclock=TIMER
  ELSE
    IF TIMER-oclock>0.02 THEN
      rgSCREENSHOW
      oclock=TIMER
    ENDIF
  ENDIF
  IF mclock THEN
    IF TIMER-mclock>0.5 THEN
      mclock=0
      rgSETMOUSE 1
    ENDIF
  ENDIF
LOOP UNTIL key="q"

' *** THE END ***
rgSCREENDELETE
IMAGEDESTROY cbitmap
' *** THE END ***



SUB LOADFONT
  DIM AS INTEGER fn = FREEFILE
  IF OPEN("retrogra.rsc/c16x8.fnt" FOR BINARY AS #fn)=0 THEN
    consolefontsize=LOF(fn)
    REDIM consolefontcontent(consolefontsize-1)
    GET #fn, 1, consolefontcontent()
    CLOSE #fn
    FOR i=0 TO 511
      consolefontpageoffset(i)=PEEK(ULONG, @consolefontcontent(0)+i*4+&H80)
    NEXT
  ELSE
    ' #todo: file open error
  ENDIF
END SUB

FUNCTION SAVEFONT AS boolean
  DIM AS BYTE zero=0
  DIM AS INTEGER fn

  IF FILEEXISTS("retrogra.rsc/c16x8.fnt") THEN
    ' write whole font data buffer in file - header data should be included
    fn=FREEFILE
    IF OPEN("retrogra.rsc/c16x8.fnt" FOR BINARY AS #fn)=0 THEN
      PUT #fn, 1, consolefontcontent()
      '      PUT #fn, , STRING(2052,CHR(0)) ' uncomment if you need a new "page"...
      CLOSE #fn
    ELSE
      ' file open error
      RETURN FALSE
    ENDIF
  ELSE
    ' font file doesn't exist, create a new one, fill with proper values...
    fn=FREEFILE
    IF OPEN("retrogra.rsc/c16x8.fnt" FOR OUTPUT AS #fn)=0 THEN
      PRINT #fn, "FNT"+CHR(10)+CHR(13);
      PRINT #fn, STRING(11,CHR(0));
      PRINT #fn, "Console Font File"+CHR(10)+CHR(13);
      PRINT #fn, STRING(13,CHR(0));
      PRINT #fn, "Homecomputer"+CHR(10)+CHR(13);
      PRINT #fn, STRING(2,CHR(0));
      PRINT #fn, CHR(0,0,0,0); ' Font file type flags (unused/=> monospaced monochrome bitmap font)
      PRINT #fn, CHR(16,0); ' font height in pixel
      PRINT #fn, CHR(8,0); ' (max) font character width in pixel
      PRINT #fn, CHR(128,0,0,0); ' bytes per 1 pixel line of 128 characters (offset)
      PRINT #fn, STRING(52,CHR(0));
      PRINT #fn, CHR(&H80,&H08,0,0); ' Offset "page" #1 / 0x00-0x7F
      PRINT #fn, CHR(&H0,&H01,0,0); ' Offset "page" #2 / 0x80-0x8F
      FOR i=0 TO 509
        PRINT #fn, CHR(0,0,0,0); ' Offset remaining pages, "0" = inexistant
      NEXT
      ' begin data bitmaps of "page" 0x000.
      PRINT #fn, CHR(0,0,0,0) ' flags, maybe 1=double width => doubling all character values above
      ' font bitmaps data
      PRINT #fn, STRING(2052, CHR(0));
      CLOSE #fn
    ELSE
      ' file open error (maybe locked)
      RETURN FALSE
    ENDIF
  ENDIF
  RETURN TRUE
END FUNCTION

SUB GETCHAR (BYVAL dstchar AS UINTEGER) ' gets the data of the 'echar' character and draws the editwindow
  DIM AS INTEGER x, y, c
  DIM AS UINTEGER poffset
  DIM AS INTEGER page

  IF dstchar<&HFFFF THEN ' get charbuffer() from font file data
    rgPRINT AT(24,6)+"U+"+hex(dstchar,4)+"    "
    page=INT(dstchar/128) ' a "page" contains 128 chars - always
    dstchar MOD=128
    IF consolefontpageoffset(page) THEN ' if "page" exists
      poffset=consolefontpageoffset(page)
      poffset+=4 ' skip "page" flags
      poffset+=dstchar ' #note: code expects 8 bit words, but it may be 16 for doublesize characters
      FOR i=0 TO 15
        charbuffer(i)=*(@consolefontcontent(0)+poffset)
        poffset+=128 ' #todo: read font file and use its line width value instead
      NEXT
    ELSE
      echar=ochar ' set previous char code as actual
      RETURN
    ENDIF
  ENDIF

  ' clear editor windows, draw pixels
  LINE (14,14)-(144,272), 0, B
  LINE (pvx-2,pvy-2)-(pvx+25,pvy+49), 0, B
  LINE (16,16)-(142,270), 215, BF
  LINE (pvx,pvy)-(pvx+23,pvy+47), 215, BF
  FOR y=0 TO 15
    i=charbuffer(y)
    FOR x=0 TO 7
      IF (i AND (1 SHL x)) THEN
        LINE (x*16+16,y*16+16)-(x*16+30,y*16+30),0,BF
        ' drawing the "preview"
        x+=pvx
        y+=pvy
        FOR j=8 TO 0 STEP -1 ' repeat 9 times
          PSET (x,y),0
          x+=8
          IF x>pvx+23 THEN
            x-=24
            y+=16
          ENDIF
        NEXT
        y-=48
        x-=pvx
        y-=pvy
      ENDIF
    NEXT
  NEXT  
END SUB

SUB SETCHAR (BYVAL dstchar AS UINTEGER) ' writes the "echar" character data into the font file data
  DIM AS INTEGER x, y, c
  DIM AS BYTE PTR poffset
  DIM AS INTEGER page=0
  
  IF dstchar=-1 THEN RETURN ' illegal/dummy value => "don't apply"

  IF dstchar>127 THEN ' requires higher "pages"
    page=INT(dstchar/128)
    dstchar MOD=128
  ENDIF

  poffset=@consolefontcontent(0)
  IF consolefontpageoffset(page) THEN
    poffset+=consolefontpageoffset(page)
  ELSE
    ' can't write :-(
    RETURN
  ENDIF
  poffset+=4 ' skip "page" flags
  poffset+=dstchar ' #note: code expects 8 bit words, but it may be 16 for doublesize characters
  FOR i=0 TO 15
    *(poffset)=charbuffer(i)
    poffset+=128 ' #todo: read font file and use its line offset entry instead
  NEXT
END SUB

SUB DRAWCHAROVERVIEW
  DIM AS INTEGER x, y, c, p
  DIM AS BYTE PTR poffset

  LINE (0,320)-(511,479),215,BF
  FOR p=0 TO 4
    IF consolefontpageoffset(p+epage) THEN
      poffset=@consolefontcontent(0)+consolefontpageoffset(p+epage)
      poffset+=4 ' skip "page" flags
      FOR y=0 TO 31
        FOR x=0 TO 63
          c=*poffset
          FOR i=0 TO 7
            IF (c AND (1 SHL i)) THEN
              PSET (x*8+i, 320+p*32+y), 0
            ENDIF
          NEXT
          poffset+=1
        NEXT
        poffset+=64 ' #note: 128 bytes per line
        IF y=15 THEN poffset-=1984 ' #note: 128 bytes per line, 64 chars shifted
      NEXT
    ENDIF
  NEXT
END SUB
