'
' UTF-8.bi
'
' UTF-8 library for FreeBASIC, helper and conversion functions
'
' UTF8(ULONG code) - turns a Unicode/ASCII value into a UTF8-Expression
'                    returns empty string on error (invalid Unicode)
'
' UNICODE(STRING substring[, INTEGER start]) - returns the Unicode value of the first UTF-8
'                    encoded character found in "substring", starts searching from "start"
'                    - first char is 1 (and/or 0)
'
' IS_VALIDUTF8(STRING string[, INTEGER start[, INTEGER end]]) - tests a given string whether
'                    all characters are valid UTF8 - returns TRUE if everything is all-right
'                    this includes pure ASCII
'                    returns FALSE the first time any illegal value appears; prevents memory
'                    leaks
' 
' UTF8LEN(STRING ) - returns length of a UTF-8 string in chars, rather than bytes
'
' UPPERCASE(STRING destination, INTEGER length=0) - tries to capitalise a UTF-8 string, turning
'                    all minuscules into majuscules, length=1 only capitalises the first letter
'
' LOWERCASE(STRING destination) - tries to turn a UTF-8 string into complete lower case,
'                    replacing all majuscules with their minuscules
'

FUNCTION UTF8(BYREF code AS ULONG) AS STRING
  IF code<128 THEN
    ' ASCII range
  ELSEIF code<&H0800 THEN
    ' 2 byte code
    UTF8=CHR(((code SHR 6) OR 192), (code AND 63)+128)
  ELSEIF code<&H10000 THEN
    ' 3 byte code
    UTF8=CHR(((code SHR 12) OR 224), ((code SHR 6) AND 63)+128, (code AND 63)+128)
  ELSEIF code<&H140000 THEN
    ' 4 byte code
    UTF8=CHR(((code SHR 18) OR 240), ((code SHR 12) AND 63)+128, ((code SHR 6) AND 63)+128, (code AND 63)+128)
  ELSE
    ' illegal code
    UTF8=""
  ENDIF
END FUNCTION

FUNCTION UNICODE(BYVAL substr AS STRING, BYVAL start AS INTEGER=0) AS ULONG
  
END FUNCTION

FUNCTION IS_VALIDUTF8(BYVAL source AS STRING, BYVAL strstart AS INTEGER=0, BYVAL strend AS INTEGER=0) AS boolean
  
END FUNCTION

FUNCTION UTF8LEN(BYVAL source AS STRING) AS INTEGER
  
END FUNCTION

FUNCTION UPPERCASE(BYVAL source AS STRING, BYVAL length AS INTEGER=0) AS STRING
  
END FUNCTION

FUNCTION LOWERCASE(BYVAL source AS STRING) AS STRING
  
END FUNCTION
